#include "Time.hpp"

Board Time::Manager::board = Board::empty();
UNumber Time::Manager::wtime = 0;
UNumber Time::Manager::btime = 0;
UNumber Time::Manager::winc = 0;
UNumber Time::Manager::binc = 0;
UNumber Time::Manager::movestogo = 0;

void Time::Manager::reset() {
    board = Board::empty();
    wtime = 0;
    btime = 0;
    winc = 0;
    binc = 0;
    movestogo = 0;
}

UNumber Time::Manager::calculate() {
    if (wtime == 0
     && btime == 0
     && winc == 0
     && binc == 0
     && movestogo == 0
    ) return -1;

    const UNumber time = (board.turn_color == WHITE)? wtime: btime;
    const UNumber inc = (board.turn_color == WHITE)? winc: binc;
	const UNumber total_moves = (movestogo == 0) ? 40 : movestogo;

	auto total_time = time + inc * total_moves;
	auto on_one_move = total_time / total_moves;

	// todo gamestages

	return on_one_move;
}
