#include "EnpassantPosibility.hpp"

EnpassantPosibility EnpassantPosibility::none() {
    return EnpassantPosibility();
}

EnpassantPosibility::EnpassantPosibility()
    : coord()
{
    // none
}

EnpassantPosibility::EnpassantPosibility(Coord acoord)
    : coord(acoord)
{
    // none
}

EnpassantPosibility EnpassantPosibility::from_fen(std::string str) {
    if (str == "-")
        return EnpassantPosibility();
    else
        return EnpassantPosibility( Coord::from_fen(str) );
}

std::string EnpassantPosibility::to_fen() const {
    if (!(*this).coord) return "-";

    return (*this).coord.get().to_fen();
}

bool EnpassantPosibility::operator==(const EnpassantPosibility& rhs) const {
    return (*this).coord == rhs.coord;
}

bool EnpassantPosibility::operator!=(const EnpassantPosibility& rhs) const {
    return (*this).coord != rhs.coord;
}
