#ifndef HISTORY
#define HISTORY

#include <map>

#include "Platform.hpp"
#include "Evaluation.hpp"
#include "Move.hpp"

namespace History {
	class Table {
	public:
        bool has(const Move&);
        void add(const Move&);
        UNumber get(const Move&);
        void remove(const Move&);
        void renew(const Move&, Score, Score, Score);
    private:
        std::map<std::pair<Coord, Coord>, UNumber> table;
	};
}

#endif
