#ifndef UCI
#define UCI

#include <vector>
#include <string>

namespace Uci {
    void uci_cycle();

	void ucinewgame_command();
	void isready_command();
	void uci_command();

	void go_command(const std::vector<std::string>&);
	void debug_command(const std::vector<std::string>&);
	void position_command(const std::vector<std::string>&);

    void perft_command(const std::vector<std::string>&);
}

#endif
